const _Http = getApp().globalData.http,
    getTime = require("../../utils/getTime");

Page({
    data: {
        showAll: false,
        disabled: true,
        content: {
          "sa_aftersalesmagid":0,
          "sa_orderid":"",
          "reason":"",
          "isitemreturn":true,
          "billdate":"",
          "type":"借用归还单"
        },
        form: [{
                label: "订单号",
                error: false,
                errMsg: "",
                type: "route",
                url: "/packageA/toolBill/modules/selectOrder/index",
                params: {
                    "id":20230105110003,
                    "content": {
                        "pageNumber": 1,
                        "pageSize": 20,
                        "where": {
                            "condition": ""
                        }
                    }
                  },
                query: '&radio=true',
                value: "",
                
                placeholder: "选择订单号",
                valueName: "sa_orderid",
                checking: "base",
                required: true,
                interrupt:true
            },
            {
                label: "单据日期",
                error: false,
                errMsg: "",
                type: "date",
                value: getTime.formatTime(new Date(),'-').split(' ')[0],
                placeholder: "请选择日期",
                valueName: "billdate",
                required: true,
            },{
                label: "返退原因",
                error: false,
                errMsg: "",
                type: "texteara",
                value: "",
                placeholder: "请输入返退原因",
                valueName: "reason",
                required: false,

            },{
                label: "是否实物退回",
                error: false,
                errMsg: "",
                type: "radio",
                radioList:[
                  {name:'是',id:1},
                  {name:'否',id:0},
                ],
                value: 1,
                valueName: "isitemreturn",
                required: true,
            },
        ]
    },
    onLoad(options) {
        if (options.rowData) {
            // wx.setNavigationBarTitle({
            //   title: 'title',
            // })
            let data = JSON.parse(options.rowData);
            console.log(data);
            this.setData({
                form: this.data.form.map(v => {
                    if (v.valueName != 'region') {
                        if (v.valueName == 'enterprisename') {
                            v.value = [data[v.valueName]]
                        } else {
                            v.value = data[v.valueName];
                        }
                    } else {
                        v.value = data.province ? [data.province, data.city, data.county] : []
                    }
                    return v
                }),
                'form[0].value': [data.sonum,[data.sa_orderid]],
                'content.sa_aftersalesmagid':data.sa_aftersalesmagid
            })
            this.selectComponent('#Form').confirm()
        }
    },
    /* 打断处理form */
    interrupt({
        detail
    }) {
        detail.form[detail.temporary.index].value = detail.data.value
        this.setData({
          form:detail.form
        })
        this.selectComponent('#Form').confirm()
        wx.navigateBack()
    },
    async submit() {
        let content = {
            ...this.data.content,
            ...this.selectComponent("#Form").submit()
        }
        content.sa_orderid = content.sa_orderid[1][0] || ''
        let res = await _Http.basic({
            "id": "20230104160503",
            content
        })
        console.log(res);
        if (res.msg == '成功') {
            wx.navigateBack()
            getCurrentPages().forEach(item => {
                if (item.__route__ == 'packageA/toolBill/index') {
                    item.getList(true)
                } else if (item.__route__ == 'packageA/toolBill/detail') {
                    item.getDetail(true)
                }
            })
        }
    },
    // 是否显示全部
    onChange({
        detail
    }) {
        this.setData({
            showAll: detail
        })
    },
    /* 表单必填项是否完成 */
    onConfirm({
        detail
    }) {
        this.setData({
            disabled: detail
        })
    }
})